﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel.Security.Tokens;
using ConexionPlatino.FirmaServicioWCF;


namespace ConexionPlatinoWCF
{

    public class PlatinofirmaServiceWCF
    {
        public PlatinoSignatureServerBeanClient cliente;

        public PlatinofirmaServiceWCF(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certifiado, bool bPre)
        {
            CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certifiado, bPre, null, null);
        }
        public PlatinofirmaServiceWCF(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certifiado, bool bPre, string[] sPlatinoParamsNombre, string[] sPlatinoParamsValor)
        {
            if (sPlatinoParamsNombre != null && sPlatinoParamsValor != null && sPlatinoParamsNombre.Length == sPlatinoParamsValor.Length)
                CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certifiado, bPre, sPlatinoParamsNombre, sPlatinoParamsValor);
            else
                CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certifiado, bPre, null, null);

        }
        private void CreaBindingCliente(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certificado, bool bPre, string[] sPlatinoParamsNombre, string[] sPlatinoParamsValor)
        {

            BindingClientePlatino myBinding = new BindingClientePlatino(true);
            EndpointAddress endPoint;

            // Creamos para pre y real
            if (bPre)              
                endPoint = new EndpointAddress(new Uri("http://buger.gobiernodecanarias.net:8077/firma/"), new DnsEndpointIdentity("PRE_UNIFICA"), new AddressHeaderCollection());
            else                
                endPoint = new EndpointAddress(new Uri("http://pavo.gobiernodecanarias.net:8077/firma/"), new DnsEndpointIdentity("UNIFICA"), new AddressHeaderCollection());

            cliente = new PlatinoSignatureServerBeanClient(myBinding, endPoint);

            cliente.Endpoint.Behaviors.Add(new MensajeInspectorBehavior(sUsernameToken, sPasswordUsernameToken, Certificado, sPlatinoParamsNombre, sPlatinoParamsValor));
        }
    }
}

