﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel.Security.Tokens;
using ConexionPlatino.RegistroEntradaSalida;

namespace ConexionPlatinoWCF
{

    public class PlatinoregistroWCF
    {
        public registroClient cliente;

        public PlatinoregistroWCF(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certificado, bool bPre)
        {
            CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certificado, bPre, null, null);
        }
        public PlatinoregistroWCF(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certificado, bool bPre, string[] sPlatinoParamsNombre, string[] sPlatinoParamsValor)
        {
            if (sPlatinoParamsNombre != null && sPlatinoParamsValor != null && sPlatinoParamsNombre.Length == sPlatinoParamsValor.Length)
                CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certificado, bPre, sPlatinoParamsNombre, sPlatinoParamsValor);
            else
                CreaBindingCliente(sUsernameToken, sPasswordUsernameToken, Certificado, bPre, null, null);

        }
        private void CreaBindingCliente(string sUsernameToken, string sPasswordUsernameToken, X509Certificate2 Certificado, bool bPre, string[] sPlatinoParamsNombre, string[] sPlatinoParamsValor)
        {
            BindingClientePlatino myBinding = new BindingClientePlatino(true);
            EndpointAddress endPoint;
            
            // Creamos para pre y real
            if (bPre)
            {               
                endPoint = new EndpointAddress(new Uri("http://buger.gobiernodecanarias.net:8076/registro/"), new DnsEndpointIdentity("PRE_UNIFICA"), new AddressHeaderCollection());
            }
            else                
                endPoint = new EndpointAddress(new Uri("http://pavo.gobiernodecanarias.net:8076/registro/"), new DnsEndpointIdentity("UNIFICA"), new AddressHeaderCollection());

            cliente = new registroClient(myBinding, endPoint);
            cliente.Endpoint.Behaviors.Add(new MensajeInspectorBehavior(sUsernameToken, sPasswordUsernameToken, Certificado, sPlatinoParamsNombre, sPlatinoParamsValor));
        }
    }
}
