﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Xml;
using System.ServiceModel.Security.Tokens;
using System.ServiceModel.Security;
using ConexionPlatinoWCF;
using System.ServiceModel.Configuration;
using ConexionPlatinoWCF.Platino;

namespace ConexionPlatinoWCF
{
    public class BindingClientePlatino : CustomBinding
    {
        public BindingClientePlatino(bool bMtom)
            : base()
        {
            // Diferenciamos entre servicios MTOM y Text
            if (bMtom)
            {
                MessageEncodingBindingElementPlatino mtomBindingElement = new MessageEncodingBindingElementPlatino();
                mtomBindingElement.MessageVersion = MessageVersion.Soap11;
                this.Elements.Add(mtomBindingElement);                
            }
            else
            {
                TextMessageEncodingBindingElement textMessageEncoding = new TextMessageEncodingBindingElement(MessageVersion.Soap11, Encoding.UTF8);
                textMessageEncoding.WriteEncoding = System.Text.Encoding.UTF8;
                textMessageEncoding.MessageVersion = MessageVersion.Soap11;

                textMessageEncoding.ReaderQuotas.MaxStringContentLength = 2147483647;
                textMessageEncoding.ReaderQuotas.MaxBytesPerRead = 2147483647;
                textMessageEncoding.ReaderQuotas.MaxDepth = 1024;
                textMessageEncoding.ReaderQuotas.MaxArrayLength = 2147483647;
                textMessageEncoding.ReaderQuotas.MaxNameTableCharCount = 2147483647;
                this.Elements.Add(textMessageEncoding);
            }
            HttpTransportBindingElement httpBindingElement = new HttpTransportBindingElement();
            httpBindingElement.MaxReceivedMessageSize = 2147483647;
            httpBindingElement.TransferMode = TransferMode.Buffered;
            this.Elements.Add(httpBindingElement);
        }
    }  
}
